## pytorch-vision 0.8.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(torchvision)
set(CMAKE_CXX_STANDARD 14)
set(TORCHVISION_VERSION 0.7.0)

option(WITH_CUDA "Enable CUDA support" OFF)

if(WITH_CUDA)
  enable_language(CUDA)
  add_definitions(-D__CUDA_NO_HALF_OPERATORS__)
  add_definitions(-DWITH_CUDA)
  set(CMAKE_CUDA_FLAGS "${CMAKE_CUDA_FLAGS} --expt-relaxed-constexpr")
endif()

find_package(Python3 COMPONENTS Development)

find_package(Torch REQUIRED)
find_package(PNG REQUIRED)
find_package(JPEG REQUIRED)

function(CUDA_CONVERT_FLAGS EXISTING_TARGET)
    get_property(old_flags TARGET ${EXISTING_TARGET} PROPERTY INTERFACE_COMPILE_OPTIONS)
    if(NOT "${old_flags}" STREQUAL "")
        string(REPLACE ";" "," CUDA_flags "${old_flags}")
        set_property(TARGET ${EXISTING_TARGET} PROPERTY INTERFACE_COMPILE_OPTIONS
            "$<$<BUILD_INTERFACE:$<COMPILE_LANGUAGE:CXX>>:${old_flags}>$<$<BUILD_INTERFACE:$<COMPILE_LANGUAGE:CUDA>>:-Xcompiler=${CUDA_flags}>"
            )
    endif()
endfunction()

file(GLOB HEADERS torchvision/csrc/*.h)
# Image extension
file(GLOB IMAGE_HEADERS torchvision/csrc/cpu/image/*.h)
file(GLOB IMAGE_SOURCES torchvision/csrc/cpu/image/*.cpp)
file(GLOB OPERATOR_SOURCES torchvision/csrc/cpu/*.h torchvision/csrc/cpu/*.cpp ${IMAGE_HEADERS} ${IMAGE_SOURCES} ${HEADERS} torchvision/csrc/*.cpp)
if(WITH_CUDA)
  file(GLOB OPERATOR_SOURCES ${OPERATOR_SOURCES} torchvision/csrc/cuda/*.h torchvision/csrc/cuda/*.cu)
endif()
file(GLOB MODELS_HEADERS torchvision/csrc/models/*.h)
file(GLOB MODELS_SOURCES torchvision/csrc/models/*.h torchvision/csrc/models/*.cpp)

if(MSVC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4819")
  if(WITH_CUDA)
    set(CMAKE_CUDA_FLAGS "${CMAKE_CUDA_FLAGS} -Xcompiler=/wd4819")
    foreach(diag cc_clobber_ignored integer_sign_change useless_using_declaration
      set_but_not_used field_without_dll_interface
      base_class_has_different_dll_interface
      dll_interface_conflict_none_assumed
      dll_interface_conflict_dllexport_assumed
      implicit_return_from_non_void_function
      unsigned_compare_with_zero
      declared_but_not_referenced
      bad_friend_decl)
      string(APPEND CMAKE_CUDA_FLAGS " -Xcudafe --diag_suppress=${diag}")
    endforeach()
    CUDA_CONVERT_FLAGS(torch_cpu)
    CUDA_CONVERT_FLAGS(torch_cuda)
  endif()
endif()

add_library(${PROJECT_NAME} SHARED ${MODELS_SOURCES} ${OPERATOR_SOURCES} ${IMAGE_SOURCES})
target_link_libraries(${PROJECT_NAME} PRIVATE ${TORCH_LIBRARIES} ${PNG_LIBRARY} ${JPEG_LIBRARIES} Python3::Python)
set_target_properties(${PROJECT_NAME} PROPERTIES EXPORT_NAME TorchVision)

include_directories(torchvision/csrc ${JPEG_INCLUDE_DIRS} ${PNG_INCLUDE_DIRS})
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

set(TORCHVISION_CMAKECONFIG_INSTALL_DIR "share/cmake/TorchVision" CACHE STRING "install path for TorchVisionConfig.cmake")

configure_package_config_file(cmake/TorchVisionConfig.cmake.in
  "${CMAKE_CURRENT_BINARY_DIR}/TorchVisionConfig.cmake"
  INSTALL_DESTINATION ${TORCHVISION_CMAKECONFIG_INSTALL_DIR})

write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/TorchVisionConfigVersion.cmake
  VERSION ${TORCHVISION_VERSION}
  COMPATIBILITY AnyNewerVersion)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/TorchVisionConfig.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/TorchVisionConfigVersion.cmake
  DESTINATION ${TORCHVISION_CMAKECONFIG_INSTALL_DIR})

install(TARGETS ${PROJECT_NAME}
  EXPORT TorchVisionTargets
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )

install(EXPORT TorchVisionTargets
  NAMESPACE TorchVision::
  DESTINATION ${TORCHVISION_CMAKECONFIG_INSTALL_DIR})

install(FILES ${HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME})
install(FILES
  torchvision/csrc/cpu/vision_cpu.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}/cpu)
if(WITH_CUDA)
  install(FILES
    torchvision/csrc/cuda/vision_cuda.h
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}/cuda)
endif()
install(FILES ${MODELS_HEADERS} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}/models)

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = torchvision
SOURCEDIR     = source
BUILDDIR      = build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

docset: html
	doc2dash --name $(SPHINXPROJ) --icon $(SOURCEDIR)/_static/img/pytorch-logo-flame.png --enable-js --online-redirect-url http://pytorch.org/vision/ --force $(BUILDDIR)/html/

	# Manually fix because Zeal doesn't deal well with `icon.png`-only at 2x resolution.
	cp $(SPHINXPROJ).docset/icon.png $(SPHINXPROJ).docset/icon@2x.png
	convert $(SPHINXPROJ).docset/icon@2x.png -resize 16x16 $(SPHINXPROJ).docset/icon.png

.PHONY: help Makefile docset

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== docs/requirements.txt ===
sphinx==1.7.3
sphinxcontrib-googleanalytics
-e git+git://github.com/pytorch/pytorch_sphinx_theme.git#egg=pytorch_sphinx_theme

=== examples/cpp/hello_world/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(hello-world)

# The first thing do is to tell cmake to find the TorchVision library.
# The package pulls in all the necessary torch libraries,
# so there is no need to also add `find_package(Torch)` here.
find_package(TorchVision REQUIRED)

add_executable(hello-world main.cpp)

# We now need to link the TorchVision library to our executable.
# We can do that by using the TorchVision::TorchVision target,
# which also adds all the necessary torch dependencies.
target_compile_features(hello-world PUBLIC cxx_range_for)
target_link_libraries(hello-world TorchVision::TorchVision)
set_property(TARGET hello-world PROPERTY CXX_STANDARD 14)

=== test/tracing/frcnn/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1 FATAL_ERROR)
project(test_frcnn_tracing)

find_package(Torch REQUIRED)
find_package(TorchVision REQUIRED)

# This due to some headers importing Python.h
find_package(Python3 COMPONENTS Development)

add_executable(test_frcnn_tracing test_frcnn_tracing.cpp)
target_compile_features(test_frcnn_tracing PUBLIC cxx_range_for)
target_link_libraries(test_frcnn_tracing ${TORCH_LIBRARIES} TorchVision::TorchVision Python3::Python)
set_property(TARGET test_frcnn_tracing PROPERTY CXX_STANDARD 14)

=== debian/changelog ===
pytorch-vision (0.8.2-1ubuntu2) jammy; urgency=medium

  * Drop X-Python3-Version: 3.9 from debian/control

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 16 Mar 2022 15:07:51 +0000

pytorch-vision (0.8.2-1ubuntu1) jammy; urgency=medium

  * Build-depend on python3-dev instead of python3-all-dev

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 11 Feb 2022 12:42:19 +0000

pytorch-vision (0.8.2-1build2) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 13 Jan 2022 20:25:24 +0000

pytorch-vision (0.8.2-1build1) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 26 Oct 2021 08:28:43 +0000

pytorch-vision (0.8.2-1) unstable; urgency=medium

  * New upstream version 0.8.2

 -- Mo Zhou <lumin@debian.org>  Thu, 17 Dec 2020 12:19:31 +0800

pytorch-vision (0.8.1-1) unstable; urgency=medium

  * New upstream version 0.8.1
  * Specify X-Python3-Version: 3.9.

 -- Mo Zhou <lumin@debian.org>  Wed, 25 Nov 2020 16:06:07 +0800

pytorch-vision (0.7.0-2) unstable; urgency=medium

  * Disable python 3.9; not yet enabled in B-D python3-torch 1.6.0.
  * Change maintainer mail address into debian-ai@l.d.o
  * Bump debhelper compat level to 13.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Wed, 21 Oct 2020 09:31:44 +0800

pytorch-vision (0.7.0-1) experimental; urgency=medium

  * New upstream version 0.7.0
  * Require libtorch-dev (>= 1.6.0) and python3-torch (>= 1.6.0) as B-D.

 -- Mo Zhou <lumin@debian.org>  Tue, 01 Sep 2020 10:48:21 +0800

pytorch-vision (0.6.1-1) experimental; urgency=medium

  * New upstream version 0.6.1
  * Add a bunch of missing build dependencies.

 -- Mo Zhou <lumin@debian.org>  Sun, 26 Jul 2020 22:16:41 +0800

pytorch-vision (0.6.0-1) experimental; urgency=medium

  * Initial release. (Closes: #958892)

 -- Mo Zhou <lumin@debian.org>  Thu, 30 Apr 2020 13:40:21 +0800

=== debian/control ===
Source: pytorch-vision
Section: science
Homepage: https://github.com/pytorch/vision
Priority: optional
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/deeplearning-team/pytorch-vision.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/pytorch-vision
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Rules-Requires-Root: no
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               libtorch-dev (>= 1.6.0),
               ninja-build,
               python3,
               python3-numpy,
               python3-pillow,
               python3-scipy,
               python3-torch (>= 1.6.0),
               python3-setuptools,
               python3-dev,
               libgflags-dev,
               libgoogle-glog-dev,
               python3-pybind11,
               pybind11-dev,

Package: python3-torchvision
Architecture: any
Depends: python3-torch, ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Description: Datasets, Transforms and Models specific to Computer Vision
 The torchvision package consists of popular datasets, model architectures, and
 common image transformations for computer vision.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PYBUILD_NAME=torchvision

%:
	dh $@ -Spybuild --with python3

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%pytorch-vision-$1.tar.gz%" \
https://github.com/pytorch/vision/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## pytorch-vision 0.13.1

=== debian/changelog ===
pytorch-vision (0.13.1-1) unstable; urgency=medium

  * New upstream version 0.13.1
  * d/watch: update regex to match correct tags.
  * B-D on python3-dev instead of -all-dev.
  * cme update dpkg-copyright.
  * Bump X-Python3-Version to 3.10
  * Bump B-D to PyTorch 1.12.0.
  * Add new B-Ds: ffmpeg, png, jpeg, pyav.
  * Recommend python3-av for the binary package.
  * Skip dh_auto_configure due to upstream setup.py
  * Apply wrap-and-sort.

 -- Mo Zhou <lumin@debian.org>  Sat, 01 Oct 2022 10:33:05 -0400

=== debian/control ===
Source: pytorch-vision
Section: science
Homepage: https://github.com/pytorch/vision
Priority: optional
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/deeplearning-team/pytorch-vision.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/pytorch-vision
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Rules-Requires-Root: no
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               ffmpeg,
               libavcodec-dev,
               libavdevice-dev,
               libavfilter-dev,
               libavformat-dev,
               libavutil-dev,
               libgflags-dev,
               libgoogle-glog-dev,
               libjpeg-dev,
               libpng-dev,
               libpostproc-dev,
               libswresample-dev,
               libswscale-dev,
               libtorch-dev (>= 1.12.0~),
               ninja-build,
               pybind11-dev,
               python3,
               python3-av,
               python3-dev,
               python3-numpy,
               python3-pillow,
               python3-pybind11,
               python3-scipy,
               python3-setuptools,
               python3-torch (>= 1.12.0~)
X-Python3-Version: 3.10

Package: python3-torchvision
Architecture: any
Depends: python3-torch, ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Recommends: python3-av
Description: Datasets, Transforms and Models specific to Computer Vision
 The torchvision package consists of popular datasets, model architectures, and
 common image transformations for computer vision.

## pytorch-vision 0.14.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project(torchvision)
set(CMAKE_CXX_STANDARD 14)
file(STRINGS version.txt TORCHVISION_VERSION)

option(WITH_CUDA "Enable CUDA support" OFF)
option(WITH_PNG "Enable features requiring LibPNG." ON)
option(WITH_JPEG "Enable features requiring LibJPEG." ON)
option(USE_PYTHON "Link to Python when building" OFF)

if(WITH_CUDA)
  enable_language(CUDA)
  add_definitions(-D__CUDA_NO_HALF_OPERATORS__)
  add_definitions(-DWITH_CUDA)
  set(CMAKE_CUDA_FLAGS "${CMAKE_CUDA_FLAGS} --expt-relaxed-constexpr")
  # CUDA-11.x can not be compiled using C++14 standard on Windows
  string(REGEX MATCH "^[0-9]+" CUDA_MAJOR ${CMAKE_CUDA_COMPILER_VERSION})
  if(${CUDA_MAJOR} GREATER 10 AND MSVC)
    set(CMAKE_CXX_STANDARD 17)
  endif()
endif()

find_package(Torch REQUIRED)

if (WITH_PNG)
    add_definitions(-DPNG_FOUND)
    find_package(PNG REQUIRED)
endif()

if (WITH_JPEG)
    add_definitions(-DJPEG_FOUND)
    find_package(JPEG REQUIRED)
endif()

if (USE_PYTHON)
  add_definitions(-DUSE_PYTHON)
  find_package(Python3 REQUIRED COMPONENTS Development)
endif()

function(CUDA_CONVERT_FLAGS EXISTING_TARGET)
    get_property(old_flags TARGET ${EXISTING_TARGET} PROPERTY INTERFACE_COMPILE_OPTIONS)
    if(NOT "${old_flags}" STREQUAL "")
        string(REPLACE ";" "," CUDA_flags "${old_flags}")
        set_property(TARGET ${EXISTING_TARGET} PROPERTY INTERFACE_COMPILE_OPTIONS
            "$<$<BUILD_INTERFACE:$<COMPILE_LANGUAGE:CXX>>:${old_flags}>$<$<BUILD_INTERFACE:$<COMPILE_LANGUAGE:CUDA>>:-Xcompiler=${CUDA_flags}>"
            )
    endif()
endfunction()

if(MSVC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4819")
  if(WITH_CUDA)
    set(CMAKE_CUDA_FLAGS "${CMAKE_CUDA_FLAGS} -Xcompiler=/wd4819")
    foreach(diag cc_clobber_ignored integer_sign_change useless_using_declaration
      set_but_not_used field_without_dll_interface
      base_class_has_different_dll_interface
      dll_interface_conflict_none_assumed
      dll_interface_conflict_dllexport_assumed
      implicit_return_from_non_void_function
      unsigned_compare_with_zero
      declared_but_not_referenced
      bad_friend_decl)
      string(APPEND CMAKE_CUDA_FLAGS " -Xcudafe --diag_suppress=${diag}")
    endforeach()
    CUDA_CONVERT_FLAGS(torch_cpu)
    if(TARGET torch_cuda)
      CUDA_CONVERT_FLAGS(torch_cuda)
    endif()
    if(TARGET torch_cuda_cu)
      CUDA_CONVERT_FLAGS(torch_cuda_cu)
    endif()
    if(TARGET torch_cuda_cpp)
      CUDA_CONVERT_FLAGS(torch_cuda_cpp)
    endif()
  endif()
endif()

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

set(TVCPP torchvision/csrc)
list(APPEND ALLOW_LISTED ${TVCPP} ${TVCPP}/io/image ${TVCPP}/io/image/cpu ${TVCPP}/models ${TVCPP}/ops
  ${TVCPP}/ops/autograd ${TVCPP}/ops/cpu ${TVCPP}/io/image/cuda)
if(WITH_CUDA)
    list(APPEND ALLOW_LISTED ${TVCPP}/ops/cuda ${TVCPP}/ops/autocast)
endif()

FOREACH(DIR ${ALLOW_LISTED})
    file(GLOB ALL_SOURCES ${ALL_SOURCES} ${DIR}/*.*)
ENDFOREACH()

add_library(${PROJECT_NAME} SHARED ${ALL_SOURCES})
target_link_libraries(${PROJECT_NAME} PRIVATE ${TORCH_LIBRARIES})

if (WITH_PNG)
    target_link_libraries(${PROJECT_NAME} PRIVATE ${PNG_LIBRARY})
endif()

if (WITH_JPEG)
    target_link_libraries(${PROJECT_NAME} PRIVATE ${JPEG_LIBRARIES})
endif()

if (USE_PYTHON)
  target_link_libraries(${PROJECT_NAME} PRIVATE Python3::Python)
endif()

set_target_properties(${PROJECT_NAME} PROPERTIES
  EXPORT_NAME TorchVision
  INSTALL_RPATH ${TORCH_INSTALL_PREFIX}/lib)

include_directories(torchvision/csrc)

if (WITH_PNG)
    include_directories(${PNG_INCLUDE_DIRS})
endif()

if (WITH_JPEG)
    include_directories(${JPEG_INCLUDE_DIRS})
endif()

set(TORCHVISION_CMAKECONFIG_INSTALL_DIR "share/cmake/TorchVision" CACHE STRING "install path for TorchVisionConfig.cmake")

configure_package_config_file(cmake/TorchVisionConfig.cmake.in
  "${CMAKE_CURRENT_BINARY_DIR}/TorchVisionConfig.cmake"
  INSTALL_DESTINATION ${TORCHVISION_CMAKECONFIG_INSTALL_DIR})

write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/TorchVisionConfigVersion.cmake
  VERSION ${TORCHVISION_VERSION}
  COMPATIBILITY AnyNewerVersion)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/TorchVisionConfig.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/TorchVisionConfigVersion.cmake
  DESTINATION ${TORCHVISION_CMAKECONFIG_INSTALL_DIR})

install(TARGETS ${PROJECT_NAME}
  EXPORT TorchVisionTargets
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  )

install(EXPORT TorchVisionTargets
  NAMESPACE TorchVision::
  DESTINATION ${TORCHVISION_CMAKECONFIG_INSTALL_DIR})

FOREACH(INPUT_DIR ${ALLOW_LISTED})
    string(REPLACE "${TVCPP}" "${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}" OUTPUT_DIR ${INPUT_DIR})
    file(GLOB INPUT_FILES ${INPUT_DIR}/*.*)
    install(FILES ${INPUT_FILES} DESTINATION ${OUTPUT_DIR})
ENDFOREACH()

=== docs/Makefile ===
--- 
+++ 
@@ -1,8 +1,12 @@
 # Minimal makefile for Sphinx documentation
 #
 
+ifneq ($(EXAMPLES_PATTERN),)
+    EXAMPLES_PATTERN_OPTS := -D sphinx_gallery_conf.filename_pattern="$(EXAMPLES_PATTERN)"
+endif
+
 # You can set these variables from the command line.
-SPHINXOPTS    =
+SPHINXOPTS    = -W -j auto $(EXAMPLES_PATTERN_OPTS)
 SPHINXBUILD   = sphinx-build
 SPHINXPROJ    = torchvision
 SOURCEDIR     = source
@@ -19,6 +23,17 @@
 	cp $(SPHINXPROJ).docset/icon.png $(SPHINXPROJ).docset/icon@2x.png
 	convert $(SPHINXPROJ).docset/icon@2x.png -resize 16x16 $(SPHINXPROJ).docset/icon.png
 
+html-noplot:  # Avoids running the gallery examples, which may take time
+	$(SPHINXBUILD) -D plot_gallery=0 -b html "${SOURCEDIR}" "$(BUILDDIR)"/html
+	@echo
+	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."
+
+clean:
+	rm -rf $(BUILDDIR)/*
+	rm -rf $(SOURCEDIR)/auto_examples/  # sphinx-gallery
+	rm -rf $(SOURCEDIR)/gen_modules/  # sphinx-gallery
+	rm -rf $(SOURCEDIR)/generated/  # autosummary
+
 .PHONY: help Makefile docset
 
 # Catch-all target: route all unknown targets to Sphinx using the new

=== docs/requirements.txt ===
matplotlib
numpy
sphinx-copybutton>=0.3.1
sphinx-gallery>=0.11.1
sphinx==5.0.0
tabulate
-e git+https://github.com/pytorch/pytorch_sphinx_theme.git#egg=pytorch_sphinx_theme

=== ios/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4.1)
set(TARGET torchvision_ops)
project(${TARGET} CXX)
set(CMAKE_CXX_STANDARD 14)
set(LIBTORCH_HEADER_ROOT ${LIBTORCH_HEADER_ROOT})
set(LIBRARY_OUTPUT_PATH ../lib)

file(GLOB VISION_SRCS
    ../torchvision/csrc/ops/cpu/*.h
    ../torchvision/csrc/ops/cpu/*.cpp
    ../torchvision/csrc/ops/*.h
    ../torchvision/csrc/ops/*.cpp)

add_library(${TARGET} STATIC
  ${VISION_SRCS}
)

file(GLOB PYTORCH_HEADERS "${LIBTORCH_HEADER_ROOT}")
file(GLOB PYTORCH_HEADERS_CSRC "${LIBTORCH_HEADER_ROOT}/torch/csrc/api/include")
target_include_directories(${TARGET} PRIVATE
  ${PYTORCH_HEADERS}
  ${PYTORCH_HEADERS_CSRC}
)

=== android/ops/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4.1)
set(TARGET torchvision_ops)
project(${TARGET} CXX)
set(CMAKE_CXX_STANDARD 14)

string(APPEND CMAKE_CXX_FLAGS " -DMOBILE")

set(build_DIR ${CMAKE_SOURCE_DIR}/build)
set(root_DIR ${CMAKE_CURRENT_LIST_DIR}/..)

file(GLOB VISION_SRCS
    ../../torchvision/csrc/ops/cpu/*.h
    ../../torchvision/csrc/ops/cpu/*.cpp
    ../../torchvision/csrc/ops/*.h
    ../../torchvision/csrc/ops/*.cpp)

add_library(${TARGET} SHARED
  ${VISION_SRCS}
)

file(GLOB PYTORCH_INCLUDE_DIRS "${build_DIR}/pytorch_android*.aar/headers")
file(GLOB PYTORCH_INCLUDE_DIRS_CSRC "${build_DIR}/pytorch_android*.aar/headers/torch/csrc/api/include")
file(GLOB PYTORCH_LINK_DIRS "${build_DIR}/pytorch_android*.aar/jni/${ANDROID_ABI}")

target_compile_options(${TARGET} PRIVATE
  -fexceptions
)

set(BUILD_SUBDIR ${ANDROID_ABI})

find_library(PYTORCH_LIBRARY pytorch_jni
  PATHS ${PYTORCH_LINK_DIRS}
  NO_CMAKE_FIND_ROOT_PATH)

find_library(FBJNI_LIBRARY fbjni
  PATHS ${PYTORCH_LINK_DIRS}
  NO_CMAKE_FIND_ROOT_PATH)

target_include_directories(${TARGET} PRIVATE
  ${PYTORCH_INCLUDE_DIRS}
  ${PYTORCH_INCLUDE_DIRS_CSRC}
)

target_link_libraries(${TARGET} PRIVATE
  ${PYTORCH_LIBRARY}
  ${FBJNI_LIBRARY}
)

=== examples/cpp/hello_world/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,10 @@
 # The package pulls in all the necessary torch libraries,
 # so there is no need to also add `find_package(Torch)` here.
 find_package(TorchVision REQUIRED)
+
+# This due to LibTorch's version is the one included in the Python
+# package that links to Python.
+find_package(Python3 COMPONENTS Development)
 
 add_executable(hello-world main.cpp)

=== debian/changelog ===
pytorch-vision (0.14.1-2) unstable; urgency=medium

  * Team upload.
  * d/control: set X-Python3-Version to 3.11 only (Closes: #1030736).

 -- Aron Xu <aron@debian.org>  Wed, 08 Feb 2023 14:18:41 +0800

pytorch-vision (0.14.1-1) unstable; urgency=medium

  [ Mo Zhou ]
  * dch: correction

  [ Debian Janitor ]
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.
  * Update standards version to 4.6.1, no changes needed.

  [ Aron Xu ]
  * Team upload.
  * New upstream version 0.14.1.

 -- Aron Xu <aron@debian.org>  Wed, 01 Feb 2023 16:17:11 +0800

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: science
 Homepage: https://github.com/pytorch/vision
 Priority: optional
-Standards-Version: 4.5.0
+Standards-Version: 4.6.1
 Vcs-Git: https://salsa.debian.org/deeplearning-team/pytorch-vision.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/pytorch-vision
 Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
@@ -36,7 +36,7 @@
                python3-scipy,
                python3-setuptools,
                python3-torch (>= 1.12.0~)
-X-Python3-Version: 3.10
+X-Python3-Version: 3.11
 
 Package: python3-torchvision
 Architecture: any

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%pytorch-vision-$1.tar.gz%" \
https://github.com/pytorch/vision/tags \
(?:.*?/)?v(\d[\d.]*)\.tar\.gz debian uupdate

## pytorch-vision 0.15.2

=== debian/changelog ===
pytorch-vision (0.15.2-1) unstable; urgency=medium

  * New upstream version 0.15.2 (Compatible w/ PyTorch 2.0.1)
  * Requires libtorch-dev >= 2.0.0~ for build depends.
  * Import upstream PR 7378 to fix FTBFS against ffmpeg 6.
  * Autopkgtest: add pytest.

 -- Mo Zhou <lumin@debian.org>  Tue, 05 Sep 2023 21:21:48 -0400

=== debian/control ===
--- 
+++ 
@@ -24,7 +24,7 @@
                libpostproc-dev,
                libswresample-dev,
                libswscale-dev,
-               libtorch-dev (>= 1.12.0~),
+               libtorch-dev (>= 2.0.0~),
                ninja-build,
                pybind11-dev,
                python3,
@@ -35,7 +35,7 @@
                python3-pybind11,
                python3-scipy,
                python3-setuptools,
-               python3-torch (>= 1.12.0~)
+               python3-torch (>= 2.0.0~)
 X-Python3-Version: 3.11
 
 Package: python3-torchvision

=== debian/tests/control ===
Test-Command: cd test/ ; python3 -c "import torchvision as V; print(V.__path__, V.__version__)"
Depends: @
Restrictions: allow-stderr
Features: test-name=py_import_and_version

# NOTE, the number of all pytest is too many (> 100k)
#       we only test a subset of them.

Test-Command: cd test/ ; pytest-3 -v test_datasets.py
Depends: @, python3-pytest, python3-pytest-mock
Restrictions: allow-stderr
Features: test-name=pytest-datasets

Test-Command: cd test/ ; pytest-3 -v test_datasets_samplers.py
Depends: @, python3-pytest
Restrictions: allow-stderr
Features: test-name=pytest-datasets-samplers

Test-Command: cd test/ ; pytest-3 -v -k "not lraspp_mobilenet_v3_large-LRASPP" test_extended_models.py
Depends: @, python3-pytest
Restrictions: allow-stderr
Features: test-name=pytest-extended-models

Test-Command: cd test/ ; pytest-3 -v test_image.py
Depends: @, python3-pytest
Restrictions: allow-stderr
Features: test-name=pytest-image

Test-Command: cd test/ ; pytest-3 -v -k "not test_write_video_with_audio" test_io.py
Depends: @, python3-pytest, python3-av
Restrictions: allow-stderr
Features: test-name=pytest-io

Test-Command: cd test/ ; pytest-3 -v test_models_detection_anchor_utils.py
Depends: @, python3-pytest
Restrictions: allow-stderr
Features: test-name=pytest-models-detection-anchor-utils

Test-Command: cd test/ ; pytest-3 -v test_models_detection_negative_samples.py
Depends: @, python3-pytest
Restrictions: allow-stderr
Features: test-name=pytest-models-detection-negative-samples

Test-Command: cd test/ ; pytest-3 -v test_models_detection_utils.py
Depends: @, python3-pytest
Restrictions: allow-stderr
Features: test-name=pytest-models-detection-utils

# Too slow.
#Test-Command: cd test/ ; pytest-3 -v test_models.py
#Depends: @, python3-pytest
#Restrictions: allow-stderr
#Features: test-name=pytest-models

Test-Command: cd test/ ; pytest-3 -v test_onnx.py
Depends: @, python3-pytest
Restrictions: allow-stderr
Features: test-name=pytest-onnx

Test-Command: cd test/ ; pytest-3 -v test_ops.py
Depends: @, python3-pytest
Restrictions: allow-stderr
Features: test-name=pytest-ops

Test-Command: cd test/ ; pytest-3 -v -k 'not test_adjust_saturation' test_transforms.py
Depends: @, python3-pytest
Restrictions: allow-stderr
Features: test-name=pytest-transforms.py

Test-Command: cd test/ ; pytest-3 -v test_transforms_tensor.py
Depends: @, python3-pytest
Restrictions: allow-stderr
Features: test-name=pytest-transforms-tensor.py

## pytorch-vision 0.19.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,23 +1,23 @@
-cmake_minimum_required(VERSION 3.12)
+cmake_minimum_required(VERSION 3.18)
 project(torchvision)
-set(CMAKE_CXX_STANDARD 14)
+set(CMAKE_CXX_STANDARD 17)
 file(STRINGS version.txt TORCHVISION_VERSION)
 
 option(WITH_CUDA "Enable CUDA support" OFF)
+option(WITH_MPS "Enable MPS support" OFF)
 option(WITH_PNG "Enable features requiring LibPNG." ON)
 option(WITH_JPEG "Enable features requiring LibJPEG." ON)
-option(USE_PYTHON "Link to Python when building" OFF)
 
 if(WITH_CUDA)
   enable_language(CUDA)
   add_definitions(-D__CUDA_NO_HALF_OPERATORS__)
   add_definitions(-DWITH_CUDA)
   set(CMAKE_CUDA_FLAGS "${CMAKE_CUDA_FLAGS} --expt-relaxed-constexpr")
-  # CUDA-11.x can not be compiled using C++14 standard on Windows
-  string(REGEX MATCH "^[0-9]+" CUDA_MAJOR ${CMAKE_CUDA_COMPILER_VERSION})
-  if(${CUDA_MAJOR} GREATER 10 AND MSVC)
-    set(CMAKE_CXX_STANDARD 17)
-  endif()
+endif()
+
+if(WITH_MPS)
+  enable_language(OBJC OBJCXX)
+  add_definitions(-DWITH_MPS)
 endif()
 
 find_package(Torch REQUIRED)
@@ -30,11 +30,6 @@
 if (WITH_JPEG)
     add_definitions(-DJPEG_FOUND)
     find_package(JPEG REQUIRED)
-endif()
-
-if (USE_PYTHON)
-  add_definitions(-DUSE_PYTHON)
-  find_package(Python3 REQUIRED COMPONENTS Development)
 endif()
 
 function(CUDA_CONVERT_FLAGS EXISTING_TARGET)
@@ -79,10 +74,13 @@
 include(CMakePackageConfigHelpers)
 
 set(TVCPP torchvision/csrc)
-list(APPEND ALLOW_LISTED ${TVCPP} ${TVCPP}/io/image ${TVCPP}/io/image/cpu ${TVCPP}/models ${TVCPP}/ops
+list(APPEND ALLOW_LISTED ${TVCPP} ${TVCPP}/io/image ${TVCPP}/io/image/cpu ${TVCPP}/io/image/cpu/giflib ${TVCPP}/models ${TVCPP}/ops
   ${TVCPP}/ops/autograd ${TVCPP}/ops/cpu ${TVCPP}/io/image/cuda)
 if(WITH_CUDA)
     list(APPEND ALLOW_LISTED ${TVCPP}/ops/cuda ${TVCPP}/ops/autocast)
+endif()
+if(WITH_MPS)
+    list(APPEND ALLOW_LISTED ${TVCPP}/ops/mps)
 endif()
 
 FOREACH(DIR ${ALLOW_LISTED})
@@ -92,16 +90,18 @@
 add_library(${PROJECT_NAME} SHARED ${ALL_SOURCES})
 target_link_libraries(${PROJECT_NAME} PRIVATE ${TORCH_LIBRARIES})
 
+if(WITH_MPS)
+  find_library(metal NAMES Metal)
+  find_library(foundation NAMES Foundation)
+  target_link_libraries(${PROJECT_NAME} PRIVATE ${metal} ${foundation})
+endif()
+
 if (WITH_PNG)
     target_link_libraries(${PROJECT_NAME} PRIVATE ${PNG_LIBRARY})
 endif()
 
 if (WITH_JPEG)
     target_link_libraries(${PROJECT_NAME} PRIVATE ${JPEG_LIBRARIES})
-endif()
-
-if (USE_PYTHON)
-  target_link_libraries(${PROJECT_NAME} PRIVATE Python3::Python)
 endif()
 
 set_target_properties(${PROJECT_NAME} PROPERTIES

=== debian/changelog ===
pytorch-vision (0.19.1-1) unstable; urgency=medium

  * New upstream version 0.19.1 (Closes: #990483, #1065722)
    This release corresponds to PyTorch 2.4.1
  * Remove outdated patches.
  * Drop Python3 version declaration from control.
  * Refresh d/copyright.
  * Update autopkgtest control file. (Closes: #1051811, #1063950)

 -- Mo Zhou <lumin@debian.org>  Thu, 03 Oct 2024 01:11:55 -0400

=== debian/control ===
--- 
+++ 
@@ -36,7 +36,6 @@
                python3-scipy,
                python3-setuptools,
                python3-torch (>= 2.0.0~)
-X-Python3-Version: 3.11
 
 Package: python3-torchvision
 Architecture: any

=== debian/tests/control ===
--- 
+++ 
@@ -15,11 +15,6 @@
 Depends: @, python3-pytest
 Restrictions: allow-stderr
 Features: test-name=pytest-datasets-samplers
-
-Test-Command: cd test/ ; pytest-3 -v -k "not lraspp_mobilenet_v3_large-LRASPP" test_extended_models.py
-Depends: @, python3-pytest
-Restrictions: allow-stderr
-Features: test-name=pytest-extended-models
 
 Test-Command: cd test/ ; pytest-3 -v test_image.py
 Depends: @, python3-pytest

## pytorch-vision 0.20.1

=== debian/changelog ===
pytorch-vision (0.20.1-1build2) plucky; urgency=medium

  * No-change rebuild for Python 3.13 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 04 Jan 2025 12:18:01 +0100

pytorch-vision (0.20.1-1build1) plucky; urgency=medium

  * No-change rebuild for pytorch.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 02 Jan 2025 23:16:51 +0000

pytorch-vision (0.20.1-1) unstable; urgency=medium

  * New upstream version 0.20.1
    This release corresponds to PyTorch 2.5.X
  * Add python3-torch-cuda as dependency. (Closes: #1077499)
  * Build against libwebp-dev for support of webp format.
  * Autopkgtest: skip test_io.py

 -- Mo Zhou <lumin@debian.org>  Wed, 01 Jan 2025 20:58:04 -0500

=== debian/control ===
--- 
+++ 
@@ -21,6 +21,7 @@
                libgoogle-glog-dev,
                libjpeg-dev,
                libpng-dev,
+               libwebp-dev,
                libpostproc-dev,
                libswresample-dev,
                libswscale-dev,
@@ -39,7 +40,7 @@
 
 Package: python3-torchvision
 Architecture: any
-Depends: python3-torch, ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
+Depends: python3-torch | python3-torch-cuda, ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
 Recommends: python3-av
 Description: Datasets, Transforms and Models specific to Computer Vision
  The torchvision package consists of popular datasets, model architectures, and

=== debian/tests/control ===
--- 
+++ 
@@ -21,10 +21,10 @@
 Restrictions: allow-stderr
 Features: test-name=pytest-image
 
-Test-Command: cd test/ ; pytest-3 -v -k "not test_write_video_with_audio" test_io.py
-Depends: @, python3-pytest, python3-av
-Restrictions: allow-stderr
-Features: test-name=pytest-io
+#Test-Command: cd test/ ; pytest-3 -v -k "not test_write_video_with_audio" test_io.py
+#Depends: @, python3-pytest, python3-av
+#Restrictions: allow-stderr
+#Features: test-name=pytest-io
 
 Test-Command: cd test/ ; pytest-3 -v test_models_detection_anchor_utils.py
 Depends: @, python3-pytest

## pytorch-vision 0.21.0

=== docs/Makefile ===
--- 
+++ 
@@ -33,6 +33,7 @@
 	rm -rf $(SOURCEDIR)/auto_examples/  # sphinx-gallery
 	rm -rf $(SOURCEDIR)/gen_modules/  # sphinx-gallery
 	rm -rf $(SOURCEDIR)/generated/  # autosummary
+	rm -rf $(SOURCEDIR)/models/generated  # autosummary
 
 .PHONY: help Makefile docset

=== examples/cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(run_model)

option(USE_TORCHVISION "Whether to link to torchvision" OFF)

find_package(Torch REQUIRED)
if(USE_TORCHVISION)
  find_package(TorchVision REQUIRED)
endif()

add_executable(run_model run_model.cpp)

target_link_libraries(run_model "${TORCH_LIBRARIES}")
if(USE_TORCHVISION)
  target_link_libraries(run_model TorchVision::TorchVision)
endif()

set_property(TARGET run_model PROPERTY CXX_STANDARD 17)

=== debian/changelog ===
pytorch-vision (0.21.0-3) unstable; urgency=medium

  * Skip tests that do not work on IBM architectures.

 -- Mo Zhou <lumin@debian.org>  Sun, 02 Mar 2025 19:07:53 -0500

pytorch-vision (0.21.0-2) unstable; urgency=medium

  * Correctly Depends on python3-torch | python3-torch-cuda.
    Although not optimal, this at least allows the user to use the
    torchvision (compiled against the CPU variant) in conjunction with
    the CUDA variant of python3-torch.

 -- Mo Zhou <lumin@debian.org>  Wed, 26 Feb 2025 13:22:59 -0500

pytorch-vision (0.21.0-1) unstable; urgency=medium

  * New upstream version 0.21.0
  * Build-Depends on PyTorch >= 2.6.0.
  * autopkgtest: Mask image tests for avif and heic due to external dependency.

 -- Mo Zhou <lumin@debian.org>  Tue, 18 Feb 2025 14:39:12 -0500

=== debian/control ===
--- 
+++ 
@@ -25,7 +25,7 @@
                libpostproc-dev,
                libswresample-dev,
                libswscale-dev,
-               libtorch-dev (>= 2.0.0~),
+               libtorch-dev (>= 2.6.0~),
                ninja-build,
                pybind11-dev,
                python3,
@@ -36,11 +36,11 @@
                python3-pybind11,
                python3-scipy,
                python3-setuptools,
-               python3-torch (>= 2.0.0~)
+               python3-torch (>= 2.6.0~)
 
 Package: python3-torchvision
 Architecture: any
-Depends: python3-torch | python3-torch-cuda, ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends},
 Recommends: python3-av
 Description: Datasets, Transforms and Models specific to Computer Vision
  The torchvision package consists of popular datasets, model architectures, and

=== debian/rules ===
--- 
+++ 
@@ -4,3 +4,6 @@
 
 %:
 	dh $@ -Spybuild --with python3
+
+override_dh_auto_clean:
+	:

=== debian/tests/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
 Restrictions: allow-stderr
 Features: test-name=pytest-datasets-samplers
 
-Test-Command: cd test/ ; pytest-3 -v test_image.py
+Test-Command: cd test/ ; pytest-3 -v -k "not avif and not heic" test_image.py 
 Depends: @, python3-pytest
 Restrictions: allow-stderr
 Features: test-name=pytest-image
@@ -56,13 +56,15 @@
 Depends: @, python3-pytest
 Restrictions: allow-stderr
 Features: test-name=pytest-ops
+Architecture: amd64 arm64 ppc64el
 
 Test-Command: cd test/ ; pytest-3 -v -k 'not test_adjust_saturation' test_transforms.py
 Depends: @, python3-pytest
 Restrictions: allow-stderr
 Features: test-name=pytest-transforms.py
 
-Test-Command: cd test/ ; pytest-3 -v test_transforms_tensor.py
+Test-Command: cd test/ ; pytest-3 -v -k 'not test_color_jitter_contrast' test_transforms_tensor.py
 Depends: @, python3-pytest
 Restrictions: allow-stderr
 Features: test-name=pytest-transforms-tensor.py
+Architecture: amd64 arm64 ppc64el
